/* $Header: */
/*********************************************************************/
/* Copyright (C) 1995, Nikos P. Chrisochoides                        */
/*                     Norhteast Parallel Architectures Center       */
/*                     e-mail:  nikos@npac.syr.edu                   */
/*                     phone :  (315) 443 3794                       */
/*                       All Rights Reserved                         */
/*                                                                   */
/*                                                                   */
/* Redistribution and use in source and binary forms are permitted   */
/* provided that this entire copyright notice is duplicated in all   */ 
/* such copies.  No charge, other than an "at-cost" distribution fee,*/ 
/* may be charged for copies, derivations, or distributions of this  */ 
/* material without the express written consent of the copyright.    */
/* holders. Neither the name of the University, nor the name of the  */
/* authors may be used to endorse or promote products derived from   */
/* this material without specific prior written permission.          */
/*                                                                   */
/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR    */
/* IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED    */
/* WARRANTIES OIMPLIED MERCHANTIBILITY AND FITNESS FOR ANY PARTICULAR*/
/* PURPOSE.                                                          */
/*********************************************************************/

#include <stdio.h>
#ifndef _pamrsl_cluster_h
#define _pamrsl_cluster_h


#define LERROR -1
#define OK 1
#define FALSE 0
#define TRUE 1


#ifndef MAX
#define MAX(x,y)                ((x > y) ? (x) : (y))
#endif
#ifndef MIN
#define MIN(x,y)                ((x < y) ? (x) : (y))
#endif
#ifndef MAX3
#define MAX3(x,y,z)             ((x > MAX(y,z) ? (x) : MAX(y,z)))
#endif

#define FALSE 0
#define TRUE 1
#define PACKINGTOL 0.5

typedef char *generic_ptr;

typedef struct _Cluster
{
  int boundary;                /* = ON if boundary OFF o/w		   */
  int ia, ib, ja, jb, ka, kb;  /* starting and ending points from level-1  */
  int *tabcells;               /* pointer to the cells of the level-1 mesh */
  int ncells;                  /* number of the cells			   */
  struct _Cluster **neighbors; /* index for neighboring clusters	   */
  int nneighbors;	       /* number of neighboring clusters	   */
}Cluster, *ClusterPtr;

typedef struct _Component
{
  generic_ptr dataptr;
  struct _Component  *next; 
}Component,  *ComponentPtr; 

typedef struct _GridComp
{
  int id;                  /* Grid component id			           */
  ClusterPtr clst;         /* pointer to cluster of elements from l-1 mesh */
}GridComp, *GridCompPtr;

typedef ComponentPtr ListPtr;

#define DATA(L) ((L)->dataptr)
#define NEXT(L) ((L)->next) 

#endif /* _pamrsl_cluster_h */
